
//
#property copyright "Copyright  2007 Steve Bowley"
#property link      "http://www.9squaredfx.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  DeepSkyBlue
#property indicator_color4  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  1
#property indicator_width4  1

//
//
//
//
//

extern int FastClosePeriod     = 5;
extern int FastCloseShift      = 0;
extern int FastCloseMode       = 1;
extern int FastClosePrice      = 0;
extern int FastOpenPeriod      = 13;
extern int FastOpenShift       = 0;
extern int FastOpenMode        = 1;
extern int FastOpenPrice       = 0;

extern int SlowClosePeriod     = 9;
extern int SlowCloseShift      = 0;
extern int SlowCloseMode       = 1;
extern int SlowClosePrice      = 0;
extern int SlowOpenPeriod      = 21;
extern int SlowOpenShift       = 0;
extern int SlowOpenMode        = 1;
extern int SlowOpenPrice       = 0;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";

//
//
//
//
//

double FastCloseBuffer[];
double FastOpenBuffer[];
double SlowCloseBuffer[];
double SlowOpenBuffer[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{

   SetIndexShift(0,FastCloseShift);
   SetIndexShift(1,FastOpenShift);
   SetIndexShift(2,SlowCloseShift);
   SetIndexShift(3,SlowOpenShift);

   IndicatorBuffers(5);
   SetIndexBuffer(0,SlowCloseBuffer); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"FastClose");
   SetIndexBuffer(1,SlowOpenBuffer);  SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"FastOpen");
   SetIndexBuffer(2,FastCloseBuffer); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"SlowClose");
   SetIndexBuffer(3,FastOpenBuffer);  SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"SlowOpen");
   SetIndexBuffer(4,trend);
   return(0);
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i = limit; i >= 0 ; i--)
   {
     
      FastCloseBuffer[i] = iMA(NULL,0,FastClosePeriod,0,FastCloseMode,FastClosePrice,i);
      FastOpenBuffer[i]  = iMA(NULL,0,FastOpenPeriod, 0,FastOpenMode, FastOpenPrice, i);
      SlowCloseBuffer[i] = iMA(NULL,0,SlowClosePeriod,0,SlowCloseMode,SlowClosePrice,i);
      SlowOpenBuffer[i]  = iMA(NULL,0,SlowOpenPeriod, 0,SlowOpenMode, SlowOpenPrice, i);
      
                trend[i] = trend[i+1];
      if (FastCloseBuffer[i] > FastOpenBuffer[i] && SlowCloseBuffer[i] > SlowOpenBuffer[i]) trend[i] = 1;
      if (FastCloseBuffer[i] < FastOpenBuffer[i] && SlowCloseBuffer[i] < SlowOpenBuffer[i]) trend[i] =-1;
    }
    
    //
    //
    //
    //
    //
      
      if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ma_4MAs_histo ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ma_4MAs_histo "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

      
      
   